--  Created by Thomas Jannaud on 25/12/07.
--  Copyright 2007 __Jannaud's Technical Company__. All rights reserved.

global lecons, nb_mots, nblecons
global lalecon, laliste, lek, lesens, lespoints, lekencours, dejarevenu, somme
global mode, fixedtab, sousmode, saut_ligne
global derniermot -- pour gérer l'appui sur les touches
global lestris, lstat, lstat2
global lasttime, stats, latouche, letemps, firsttab

on awake from nib theObject
	set lecons to {}
	set nb_mots to {}
	set nblecons to 0
	set mode to ""
	set derniermot to ""
	set fixedtab to false
	set saut_ligne to "
"
	set stats to {}
	set latouche to 30 -- le '$'
	set letemps to 2 as real
	set firsttab to "Dictionnaire"
	load_dico()
	load_stats()
	if firsttab is "Dictionnaire" then
		tell tab view "tabs" of window "frmjap" to set the current tab view item to tab view item "tabdico"
	else if firsttab is "Apprentissage" then
		tell tab view "tabs" of window "frmjap" to set the current tab view item to tab view item "tablearn"
	else if firsttab is "Visionnage" then
		tell tab view "tabs" of window "frmjap" to set the current tab view item to tab view item "tabvisio"
	else if firsttab is "Entraînement" then
		tell tab view "tabs" of window "frmjap" to set the current tab view item to tab view item "tabtrain"
	else if firsttab is "Statistiques" then
		tell tab view "tabs" of window "frmjap" to set the current tab view item to tab view item "tabstat"
	end if
	repeat with i from 1 to nblecons
		make new combo box item at end of combo box items of combo box "poplecons" of window "frmjap" with data "Leçon " & i
	end repeat
	tell window "frmoptions" to hide
	make new combo box item at end of combo box items of combo box "choixtab" of window "frmoptions" with data "Dictionnaire"
	make new combo box item at end of combo box items of combo box "choixtab" of window "frmoptions" with data "Statistiques"
	make new combo box item at end of combo box items of combo box "choixtab" of window "frmoptions" with data "Apprentissage"
	make new combo box item at end of combo box items of combo box "choixtab" of window "frmoptions" with data "Entraînement"
	make new combo box item at end of combo box items of combo box "choixtab" of window "frmoptions" with data "Visionnage"
	
end awake from nib

on clicked theObject
	if the name of theObject is "btnbegin" and the title of theObject is "Commencer" then
		lancer_learn()
	else if the name of theObject is "btnbegin" and the title of theObject is "Arrêter" then
		veut_terminer_learn()
	end if
	if the name of theObject is "btnbegintrain" and the title of theObject is "Commencer" then
		lancer_train()
	else if the name of theObject is "btnbegintrain" and the title of theObject is "Arrêter" then
		veut_terminer_train()
	end if
	if the name of theObject is "btnsaveoptions" then
		set latouche to (content of text field "lbltouche" of window "frmoptions") as integer
		set a to content of text field "lbltime" of window "frmoptions"
		set letemps to (word 1 of a) as real
		set firsttab to (content of combo box "choixtab" of window "frmoptions") as string
	end if
	if the name of theObject is "btndefaults" then
		set content of text field "lbltouche" of window "frmoptions" to 30
		set content of text field "lbltime" of window "frmoptions" to "3,00 s"
		set content of combo box "choixtab" of window "frmoptions" to "Dictionnaire"
	end if
end clicked

on keyboard up theObject event theEvent
	if the name of theObject is "txtdico" then
		if key code of theEvent is latouche then
			set content of text field "txtdico" of tab view item "tabdico" of tab view "tabs" of window "frmjap" to derniermot
			set ll to chercher(derniermot)
			set contents of text view "lbldico" of scroll view "scrdico" of tab view item "tabdico" of tab view "tabs" of window "frmjap" to (ll as string)
		else
			set derniermot to content of text field "txtdico" of tab view item "tabdico" of tab view "tabs" of window "frmjap"
		end if
	end if
	if the name of theObject is "txtlearn" then
		if key code of theEvent is latouche then
			set content of text field "txtlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to derniermot
			if sousmode is "5 mots" then
				tester_learn()
			else if sousmode is "ecrit" then
				verification_learn()
			else if sousmode is "correction" then
				if fini_tranche() then
					nouveau_learn()
				else
					tester_learn()
				end if
			end if
		else
			set derniermot to content of text field "txtlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap"
		end if
	end if
	if the name of theObject is "txttrain" then
		if key code of theEvent is latouche then
			set content of text field "txttrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap" to derniermot
			if sousmode is "ecrit" then
				verification_train()
			else if sousmode is "correction" then
				if fini_train() then
					congratulations_train()
				else
					tester_train()
				end if
			end if
		else
			set derniermot to content of text field "txttrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap"
		end if
	end if
	if the name of theObject is "txttouche" then
		set content of text field "lbltouche" of window "frmoptions" to (key code of theEvent)
		set content of text field "txttouche" of window "frmoptions" to ""
	end if
end keyboard up

on selected tab view item theObject tab view item tabViewItem
	if name of tabViewItem is "tabdico" then
		set mode to "dico"
		set derniermot to ""
		set content of text field "txtdico" of tab view item "tabdico" of tab view "tabs" of window "frmjap" to ""
	else if name of tabViewItem is "tabtrain" then
		set mode to "train"
		set sousmode to "rien"
		set derniermot to ""
		set content of text field "txttrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap" to ""
	else if name of tabViewItem is "tablearn" then
		set mode to "learn"
		set sousmode to "rien"
		set derniermot to ""
		set content of text field "txtlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to ""
	else if name of tabViewItem is "tabvisio" then
		set lek to 1
		set lesens to iif(content of control "franjap" of window "frmjap" is 0, "J->F", "F->J")
		set a to content of combo box "poplecons" of window "frmjap"
		set lalecon to (word 2 of a) as integer
		set laliste to liste_aleatoire(item lalecon of nb_mots)
		set sousmode to 1
		set lasttime to ((current date) - letemps - 1)
		set mode to "visio"
	else
		affiche_stats()
		set mode to "stats"
	end if
end selected tab view item

on should select tab view item theObject tab view item tabViewItem
	return (not fixedtab)
end should select tab view item

on column clicked theObject table column tableColumn
	set i to identifier of tableColumn as integer
	set deb to iif(i < 4, 1, 4)
	set fin to iif(i < 4, 3, 7)
	set a to item i of lestris
	repeat with j from deb to fin
		set item j of lestris to "rien"
	end repeat
	if a is "rien" or a is "croiss" then
		set item i of lestris to "decr"
	else
		set item i of lestris to "croiss"
	end if
	if i < 4 then
		trier(lstat, i, iif(item i of lestris is "croiss", 1, 2))
		set content of table view "tabviewlearn" of scroll view "scrstatlearn" of tab view item "tabstat" of tab view "tabs" of window "frmjap" to lstat
		
	else
		trier(lstat2, i - 3, iif(item i of lestris is "croiss", 1, 2))
		set content of table view "tabviewtrain" of scroll view "scrstattrain" of tab view item "tabstat" of tab view "tabs" of window "frmjap" to lstat2
	end if
	
end column clicked

on choose menu item theObject
	set a to name of theObject
	if a = "mnuquit" then
		quitter()
	else if a = "mnupreferences" then
		tell window "frmoptions" to show
	else if a = "mnuabout" then
		tell window "frmabout" to show
	end if
	
end choose menu item

on should close theObject
	if theObject is window "frmoptions" or theObject is window "frmabout" then
		set visible of theObject to false
		return false
	else
		quitter()
	end if
end should close

on action theObject -- le slider pour le temps
	set a to content of theObject
	set content of text field "lbltime" of window "frmoptions" to format(a)
end action

on idle theObject
	if mode is "visio" then
		if ((current date) - lasttime) > letemps then
			set lasttime to current date
			if lek > (item lalecon of nb_mots) then set lek to 1
			set lekk to item lek of laliste
			set a to item 1 of item lekk of item lalecon of lecons as string
			set b to (item 2 of item lekk of item lalecon of lecons as string) & saut_ligne & saut_ligne & (item 3 of item lekk of item lalecon of lecons as string)
			if sousmode is 1 then set texte to iif(lesens is "F->J", a, b) -- "mode 1 " & lek & " " & (random number)
			if sousmode is 2 then
				set texte to iif(lesens is "F->J", a & saut_ligne & saut_ligne & b, b & saut_ligne & saut_ligne & a) --"mode 2 " & lek & " " & (random number) 
				set lek to lek + 1
			end if
			set sousmode to 3 - sousmode
			set content of text view "lblvisio" of scroll view "scrvisio" of tab view item "tabvisio" of tab view "tabs" of window "frmjap" to texte
			return letemps
		end if
	end if
end idle

on lancer_learn()
	set visible of text field "txtlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to true
	set enabled of control "franjap" of window "frmjap" to false
	set enabled of combo box "poplecons" of window "frmjap" to false
	set title of button "btnbegin" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to "Arrêter"
	set fixedtab to true
	set lek to 1
	set lesens to iif(content of control "franjap" of window "frmjap" is 0, "J->F", "F->J")
	set a to content of combo box "poplecons" of window "frmjap"
	set lalecon to (word 2 of a) as integer
	set laliste to liste_aleatoire(item lalecon of nb_mots)
	set sousmode to "5 mots"
	set lespoints to {0, 0, 0, 0, 0}
	afficher_learn()
end lancer_learn

on afficher_learn()
	set n to (item lalecon of nb_mots)
	set a to iif(lek ≤ (n - 4), 5, n + 1 - lek)
	set texte to ""
	repeat with i from 0 to (a - 1)
		set b to item (i + lek) of laliste
		set texte to texte & item 1 of item b of item lalecon of lecons & " <-> " & item 2 of item b of item lalecon of lecons & " <=> " & item 3 of item b of item lalecon of lecons & saut_ligne
	end repeat
	set contents of text view "lbllearn" of scroll view "scrlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to texte
	set contents of text field "txtlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to ""
end afficher_learn

on tester_learn()
	set n to (item lalecon of nb_mots)
	set a to iif(lek ≤ (n - 4), 5, n + 1 - lek)
	set ok to false
	repeat until ok
		set b to 1 + floor(a * (random number))
		set c to random number
		set d to item b of lespoints
		if c * d * d < 0.5 then set ok to true
		if d = 3 then set ok to false
	end repeat
	set e to item (b - 1 + lek) of laliste
	if lesens = "F->J" then
		set texte to item 1 of item e of item lalecon of lecons
	else
		set texte to item 2 of item e of item lalecon of lecons & " <=> " & item 3 of item b of item lalecon of lecons
	end if
	set contents of text view "lbllearn" of scroll view "scrlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to texte
	set contents of text field "txtlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to ""
	set sousmode to "ecrit"
	set lekencours to (b - 1 + lek)
end tester_learn

on verification_learn()
	set a to contents of text field "txtlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap"
	set ii to item lekencours of laliste
	set b to item 1 of item ii of item lalecon of lecons
	set c to item 2 of item ii of item lalecon of lecons
	set d to item 3 of item ii of item lalecon of lecons
	set f to (lekencours + 1 - lek)
	set thepoint to item f of lespoints
	if ((lesens is "F->J") and (a is c or a is d)) or ((lesens is "J->F") and (a is b)) then
		set texte to "C'est juste." & saut_ligne & saut_ligne & b & saut_ligne & c & saut_ligne & d
		set item f of lespoints to (1 + thepoint)
	else
		set texte to "C'est faux." & saut_ligne & saut_ligne & b & saut_ligne & c & saut_ligne & d
		set item f of lespoints to iif(thepoint = 0, 0, thepoint - 1)
	end if
	set contents of text view "lbllearn" of scroll view "scrlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to texte
	set sousmode to "correction"
end verification_learn

on nouveau_learn()
	set lek to lek + 5
	if lek > (item lalecon of nb_mots) then
		display dialog "Vous venez de terminer l'apprentissage de la leçon " & lalecon & ". Continuez comme ça !" buttons {"Ok"} default button 1
		set a to a reference to item lalecon of stats
		set datelearn of a to make_date()
		set nblearn of a to (1 + (nblearn of a))
		achever_learn()
	else
		set sousmode to "5 mots"
		set lespoints to {0, 0, 0, 0, 0}
		afficher_learn()
	end if
end nouveau_learn

on veut_terminer_learn()
	display dialog "Etes-vous sûr de vouloir arrêter l'apprentissage en cours de route ?" buttons {"Oui", "Non"} default button 2
	if the button returned of the result is "Oui" then
		achever_learn()
	end if
end veut_terminer_learn

on achever_learn()
	set sousmode to "fini"
	set visible of text field "txtlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to false
	set contents of text view "lbllearn" of scroll view "scrlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to " "
	set contents of text field "txtlearn" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to ""
	set enabled of control "franjap" of window "frmjap" to true
	set enabled of combo box "poplecons" of window "frmjap" to true
	set title of button "btnbegin" of tab view item "tablearn" of tab view "tabs" of window "frmjap" to "Commencer"
	set fixedtab to false
end achever_learn

on fini_tranche()
	set n to (item lalecon of nb_mots)
	set a to iif(lek ≤ (n - 4), 5, n + 1 - lek)
	set l to {}
	repeat with i from 1 to a
		copy 3 to the end of l
	end repeat
	repeat with i from 1 to (5 - a)
		copy 0 to the end of l
	end repeat
	return (lespoints is equal to l)
end fini_tranche

on lancer_train()
	set visible of text field "txttrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap" to true
	set enabled of control "franjap" of window "frmjap" to false
	set enabled of combo box "poplecons" of window "frmjap" to false
	set title of button "btnbegintrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap" to "Arrêter"
	set fixedtab to true
	set lek to 0
	set lesens to iif(content of control "franjap" of window "frmjap" is 0, "J->F", "F->J")
	set a to content of combo box "poplecons" of window "frmjap"
	set lalecon to (word 2 of a) as integer
	set laliste to liste_aleatoire(item lalecon of nb_mots)
	set sousmode to "ecrire"
	set lespoints to uneliste(item lalecon of nb_mots, 0)
	set somme to 0
	set dejarevenu to false
	tester_train()
end lancer_train

on tester_train()
	set lek to lek + 1
	set n to (item lalecon of nb_mots)
	set trouve to false
	repeat with i from lek to n
		if (item i of lespoints) = 0 then
			set trouve to true
			exit repeat
		end if
	end repeat
	if not trouve then -- on est assuré d'en trouver un sinon on ne serait pas dans cette sub
		set dejarevenu to true
		repeat with i from 1 to lek
			if (item i of lespoints) = 0 then
				exit repeat
			end if
		end repeat
	end if
	set lek to i
	set lekencours to item lek of laliste
	set e to lekencours
	if lesens = "F->J" then
		set texte to item 1 of item e of item lalecon of lecons
	else
		set texte to item 2 of item e of item lalecon of lecons & " <=> " & item 3 of item e of item lalecon of lecons
	end if
	set contents of text view "lbltrain" of scroll view "scrtrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap" to texte
	set contents of text field "txttrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap" to ""
	set sousmode to "ecrit"
end tester_train

on verification_train()
	set a to contents of text field "txttrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap"
	set b to item 1 of item lekencours of item lalecon of lecons
	set c to item 2 of item lekencours of item lalecon of lecons
	set d to item 3 of item lekencours of item lalecon of lecons
	if ((lesens is "F->J") and (a is c or a is d)) or ((lesens is "J->F") and (a is b)) then
		set texte to "C'est juste." & saut_ligne & saut_ligne & b & saut_ligne & c & saut_ligne & d
		set item lek of lespoints to 1
		if not dejarevenu then set somme to somme + 1
	else
		set texte to "C'est faux." & saut_ligne & saut_ligne & b & saut_ligne & c & saut_ligne & d
		set item lek of lespoints to 0 -- ca y était déja a priori
	end if
	set contents of text view "lbltrain" of scroll view "scrtrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap" to texte
	set sousmode to "correction"
end verification_train

on fini_train()
	set oui to true
	set n to item lalecon of nb_mots
	repeat with i from 1 to n
		if item i of lespoints = 0 then
			set oui to false
			exit repeat
		end if
	end repeat
	return oui
end fini_train

on congratulations_train()
	set pourcen to ((somme as real) * 100.0 / ((item lalecon of nb_mots) as real)) as integer
	set pourcent to pourcen & " %"
	display dialog "Vous venez de terminer l'entraînement de la leçon " & lalecon & " avec " & pourcent & " de réussite. Continuez comme ça !" buttons {"Ok"} default button 1
	set a to a reference to item lalecon of stats
	set datetrain of a to make_date()
	set nbtrain of a to (1 + (nbtrain of a))
	set somtrain of a to (somme + (somtrain of a))
	achever_train()
end congratulations_train

on veut_terminer_train()
	display dialog "Etes-vous sûr de vouloir arrêter l'entraînement en cours de route ?" buttons {"Oui", "Non"} default button 2
	if the button returned of the result is "Oui" then
		achever_train()
	end if
end veut_terminer_train

on achever_train()
	set sousmode to "fini"
	set visible of text field "txttrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap" to false
	set contents of text view "lbltrain" of scroll view "scrtrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap" to " "
	set contents of text field "txttrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap" to ""
	set enabled of control "franjap" of window "frmjap" to true
	set enabled of combo box "poplecons" of window "frmjap" to true
	set title of button "btnbegintrain" of tab view item "tabtrain" of tab view "tabs" of window "frmjap" to "Commencer"
	set fixedtab to false
end achever_train

on liste_aleatoire(n)
	set l to {}
	repeat with i from 1 to n
		copy i to the end of l
	end repeat
	repeat with i from 1 to (n - 1)
		set a to (i + floor((random number) * (n - i + 1)))
		set b to item a of l
		set item a of l to item i of l
		set item i of l to b
	end repeat
	return l
end liste_aleatoire

on uneliste(a, b)
	set l to {}
	repeat a times
		copy b to the end of l
	end repeat
	return l
end uneliste

on format(a) -- on  veut 0,00 s comme format
	set b to a as string
	if length of b < 4 then set b to b & "0000"
	set l to every character of b
	set item 2 of l to ","
	return ((items 1 thru 4 of l) as string) & " s"
end format

on format2(a) -- on  veut 00 comme format
	set b to a as string
	if length of b < 2 then set b to "0" & b
	return b
end format2

on floor(a)
	set b to a as integer
	return iif(a < b, b - 1, b)
end floor

on iif(a, b, c)
	if a then
		return b
	else
		return c
	end if
end iif

on make_date()
	set a to current date
	set b to month of a as integer
	return format2(day of a) & "-" & format2(b) & "-" & format2((year of a) - 2000)
end make_date

on trier(l, i, ordre) -- 1 : croissant, 2 : décroissant
	set n to length of l
	-- on retire tous les "jamais"
	set b to 0
	if ordre is 1 then -- croissant
		repeat with j from 1 to n
			if item i of item j of l is "jamais" then
				set b to b + 1
				set a to item j of l
				set item j of l to item b of l
				set item b of l to a
			end if
		end repeat
		set deb to b + 1
		set fin to n
	else
		repeat with j from n to 1 by (-1)
			if item i of item j of l is "jamais" then
				set a to item j of l
				set item j of l to item (n - b) of l
				set item (n - b) of l to a
				set b to b + 1
			end if
		end repeat
		set deb to 1
		set fin to (n - b)
	end if
	
	repeat with j from deb to (fin - 1)
		set mini to item i of item j of l
		set indice to j
		repeat with k from (j + 1) to fin
			if ordre is 1 and (item i of item k of l) < mini then -- croissant
				set mini to item i of item k of l
				set indice to k
			else if ordre is 2 and (item i of item k of l) > mini then -- décroissant
				set mini to item i of item k of l
				set indice to k
			end if
		end repeat
		set a to item j of l
		set item j of l to item indice of l
		set item indice of l to a
	end repeat
end trier

on chercher(mot)
	set liste to {}
	set nb to 0
	repeat with i from 1 to nblecons
		set nblec to item i of nb_mots as integer
		repeat with j from 1 to nblec
			set ok to false
			set special to false
			repeat with k from 1 to 3
				set a to item k of item j of item i of lecons
				if a ≠ "" and (a contains mot or mot contains a) then
					set ok to true
				end if
				if a is equal to mot then
					set special to true
				end if
			end repeat
			if ok and not special then
				set nb to (nb + 1)
				copy "lecon " & i & saut_ligne to the end of liste
				copy (item 1 of item j of item i of lecons) & saut_ligne to the end of liste
				copy (item 2 of item j of item i of lecons) & saut_ligne to the end of liste
				copy (item 3 of item j of item i of lecons) & saut_ligne to the end of liste
				copy saut_ligne to the end of liste
			end if
			if special then
				set nb to (nb + 1)
				copy saut_ligne to the beginning of liste
				copy (item 3 of item j of item i of lecons) & saut_ligne to the beginning of liste
				copy (item 2 of item j of item i of lecons) & saut_ligne to the beginning of liste
				copy (item 1 of item j of item i of lecons) & saut_ligne to the beginning of liste
				copy "lecon " & i & saut_ligne to the beginning of liste
			end if
			if nb ≥ 15 then exit repeat
		end repeat
		if nb ≥ 15 then exit repeat
	end repeat
	if nb = 0 then
		set liste to {"Aucune correspondance"}
	end if
	
	return liste
	
end chercher

on load_dico()
	--	set tout to {"2", "lecon 1", "2", "docteur", "いしゃ", "医者", "", "moi", "わたし", "私", "", "lecon 2", "2", "docteur", "いしゃ", "医者", "", "moi", "わたし", "私", "", ""}
	ledico()
	set nblecons to 1
	repeat with i from 1 to nblecons
		copy (length of (item i of lecons)) to the end of nb_mots
	end repeat
end load_dico

on verifie_fichier_stats()
	tell application "Finder"
		set thefold1 to folder "Application Support" of folder "Library" of home
		set thefold to (thefold1 as text) & "Le Japonais"
		if not (exists thefold) then make new folder at folder "Application Support" of folder "Library" of home with properties {name:"Le Japonais"}
		if not (exists thefold & ":stats.txt") then
			make new file at folder thefold with properties {name:"stats.txt"}
			set thepath to file "stats.txt" of folder "Le Japonais" of folder "Application Support" of folder "Library" of home as alias
			set l to (latouche as string) & saut_ligne & (letemps as string) & saut_ligne & (firsttab as string)
			open for access thepath with write permission
			write l to thepath
			close access thepath
		end if
	end tell
end verifie_fichier_stats

on load_stats()
	verifie_fichier_stats()
	--	set stats to {{datelearn:"10-11-07", nblearn:2, datetrain:"11-11-07", nbtrain:3, somtrain:4}, {datelearn:"10-11-06", nblearn:1, datetrain:"11-07-05", nbtrain:2, somtrain:3}}
	tell application "Finder"
		set thepath to file "stats.txt" of folder "Le Japonais" of folder "Application Support" of folder "Library" of home as alias
		open for access thepath with write permission
		set l to read thepath
		close access thepath
	end tell
	set ll to every paragraph of l
	set latouche to ((item 1 of ll) as integer)
	set letemps to ((item 2 of ll) as real)
	set firsttab to ((item 3 of ll) as string)
	set n to ((length of ll) - 3) / 5
	set i to 4
	repeat n times
		copy {datelearn:item i of ll, nblearn:(item (i + 1) of ll) as integer, datetrain:item (i + 2) of ll, nbtrain:(item (i + 3) of ll) as integer, somtrain:(item (i + 4) of ll) as integer} to the end of stats
	end repeat
	if length of stats < nblecons then
		repeat (nblecons - (length of stats)) times
			copy {datelearn:"jamais", nblearn:0, datetrain:"jamais", nbtrain:0, somtrain:0} to the end of stats
		end repeat
	end if
end load_stats

on affiche_stats()
	set n to nblecons
	set lstat to {} -- est global
	repeat with i from 1 to n
		copy {i, datelearn of item i of stats, nblearn of item i of stats} to the end of lstat
	end repeat
	set content of table view "tabviewlearn" of scroll view "scrstatlearn" of tab view item "tabstat" of tab view "tabs" of window "frmjap" to lstat
	set lstat2 to {} -- est global
	repeat with i from 1 to n
		copy {i, datetrain of item i of stats, pourcents(i), nbtrain of item i of stats} to the end of lstat2
	end repeat
	set content of table view "tabviewtrain" of scroll view "scrstattrain" of tab view item "tabstat" of tab view "tabs" of window "frmjap" to lstat2
	set lestris to {"croiss", "rien", "rien", "croiss", "rien", "rien", "rien"}
end affiche_stats

on pourcents(i)
	set n to nbtrain of item i of stats
	set nbb to item i of nb_mots
	set s to somtrain of item i of stats
	if n = 0 then
		return ""
	else
		set a to ((s * 100) as real) / ((nbb * n) as real) as integer
		return a -- & " %"
	end if
end pourcents

on sauvegarde_stats()
	set l to (latouche as string) & saut_ligne & (letemps as string) & saut_ligne & firsttab & saut_ligne
	repeat with i in stats
		set l to l & datelearn of i & saut_ligne
		set l to (l & (nblearn of i) as string) & saut_ligne
		set l to (l & (datetrain of i) as string) & saut_ligne
		set l to (l & (nbtrain of i) as string) & saut_ligne
		set l to (l & (somtrain of i) as string) & saut_ligne
	end repeat
	tell application "Finder" to set thepath to file "stats.txt" of folder "Le Japonais" of folder "Application Support" of folder "Library" of home as alias
	open for access thepath with write permission
	write l to thepath
	close access thepath
end sauvegarde_stats

on quitter()
	sauvegarde_stats()
	quit
end quitter

on ledico()
	set lecons to {}
	copy {{"je", "わたし", "私"}, {"nous", "わたしたち", ""}, {"vous", "あなた", ""}, {"cette personne", "あのひと", "あの人"}, {"vous tous", "みなさん", "皆さん"}, {"professeur", "せんせい", "先生"}, {"instituteur", "きょうし", "教師"}, {"étudiant", "がくせい", "学生"}, {"employé", "かいしゃいん", "会社員"}, {"médecin", "いしゃ", "医者"}, {"chercheur", "けんきゅうしゃ", "研究者"}, {"ingénieur", "エンジニア", ""}, {"université", "だいがく", "大学"}, {"hôpital", "びょういん", "病院"}, {"électricité", "でんき", "電気"}, {"qui", "だれ", ""}, {"quel âge", "おいくつ", "何歳"}} to the end of lecons
end ledico